<?php

namespace TrainingWheels\Conn;
use TrainingWheels\Log\Log;
use Exception;

set_include_path(get_include_path() . PATH_SEPARATOR . 'sites/all/libraries/phpseclib');

require_once('Net/SSH2.php');

class SSHServerConn implements ServerConn {
  protected $ip;
  protected $port;
  protected $user;
  protected $pass;
  protected $ssh_conn;

  public function __construct($ip, $port, $user, $pass) {
    $this->ip = $ip;
    $this->port = $port;
    $this->user = $user;
    $this->pass = $pass;
  }

  public function connect() {
    $this->ssh_conn = new \Net_SSH2($this->ip, $this->port);
    return $this->ssh_conn->login($this->user, $this->pass);
  }

  public function exec($command) {
    if ($this->ssh_conn) {
      $result = trim($this->ssh_conn->exec($command));
      // Get the calling function for debugging.
      $e = new Exception();
      $trace = $e->getTrace();
      $caller = $trace[1]['function'] . ' in ' . basename($trace[1]['file']);
      Log::log('>>> ' . $caller, L_VERBOSE);
      Log::log('exec: ' . $command, L_DEBUG);
      Log::log('outp: ' . $result, L_DEBUG);
      return $result;
    }
    else {
      throw new Exception('SSH connection has not been established');
    }
  }
}