<?php

namespace TrainingWheels\Environment;

abstract class TrainingEnv {
  /**
   * Verify a MySQL username.
   */
  public function mySQLVerifyUserName($user) {
    if (preg_match('/^[0-9a-zA-Z_]+$/', $user) === 0) {
      throw new Exception("MySQL username contains an invalid character, '$user'");
    }
    if (strlen($user) > 16) {
      throw new Exception("MySQL username cannot be longer than 16 characters, '$user'");
    }
    return TRUE;
  }

  /**
   * Verify a MySQL database name.
   */
  public function mySQLVerifyDBName($db) {
    if (preg_match('/^[0-9a-zA-Z_$]+$/', $db) === 0) {
      throw new Exception("MySQL database name contains an invalid char, '$db'");
    }
    return TRUE;
  }
}